import Vue, { ComponentOptions, Component } from 'vue';
import { Dispatch, Commit } from 'vuex';
export declare type TransformFunction = (options: ComponentOptions<any>, lifecycle: Record<string, Function>) => void;
export declare type StateMapper<S, G> = string | ((this: Vue, state: S, getters: G) => any);
export declare type ActionMapper = string | ((this: Vue, dispatch: Dispatch, ...args: any[]) => any);
export declare type MutationMapper = string | ((this: Vue, commit: Commit, ...args: any[]) => any);
export interface ConnectOptions<S, G> {
    stateToProps?: Record<string, StateMapper<S, G>> | string[];
    gettersToProps?: Record<string, string> | string[];
    actionsToProps?: Record<string, ActionMapper> | string[];
    actionsToEvents?: Record<string, ActionMapper> | string[];
    mutationsToProps?: Record<string, MutationMapper> | string[];
    mutationsToEvents?: Record<string, MutationMapper> | string[];
    lifecycle?: Record<string, Function>;
}
export declare function createConnect<StateType = any, GettersType = any>(transform?: TransformFunction): <S = StateType, G = GettersType>(options?: ConnectOptions<S, G>) => {
    <C extends Component<import("vue/types/options").DefaultData<never>, import("vue/types/options").DefaultMethods<never>, import("vue/types/options").DefaultComputed, Record<string, any>>>(name: string | C, Component: C): C;
    <C extends Component<import("vue/types/options").DefaultData<never>, import("vue/types/options").DefaultMethods<never>, import("vue/types/options").DefaultComputed, Record<string, any>>>(name: C): C;
};
